/**
 * Stars!
 * 艦隊クラス
 *
 * $Id: stars_fleet.js,v 1.9 2006/03/11 14:31:37 shio Exp $
 */

// 艦隊表示クラス
function clickDispFleet() {
    if (app.selectMode) {
        app.finishSelectMode();
        cancelSCmd();
    }
    var e = document.getElementById("subWindow");
    var body =  document.getElementById("subBody");
    var width = 350;
    var height = 300;
	var imgfile = (isIE()) ? "subwin3.gif" : "subwin3.png";
    app.subWinData.width = width;
    app.subWinData.height = height;

    e.style.width = width + "px";
    e.style.height = height + "px";

    var windowTitle = document.getElementById("windowTitle");
    document.getElementById("windowTitleText").innerHTML="艦隊一覧";

    var img = document.getElementById("subwinimg");
    img.setAttribute("src", imgfile);
    var flist = makeFleetList();
    var str = '<div id="sub_name" style="width: 345px; height: 250px">';
    str += "<table class='fleetTable' style='font-size: 13px;'>";
    str += "<tr bgcolor='000000'>";
    str += "<th>No.</th>";
    str += "<th>航宙L</th>";
    str += "<th>軍事L</th>";
    str += "<th>所属植民星</th>";
    str += "<th>練度</th>";
    str += "<th>経験</th>";
    str += "<th>廃棄</th>";
    str += "</tr>";
    for (var i = 0; i < flist.length; i++) {
        str += "<tr>";
        str += "<td>" + flist[i].no + "</td>";
        str += "<td>" + flist[i].nvg + "</td>";
        str += "<td>" + flist[i].mlt + "(" + flist[i].getExpMlt() + ")</td>";
        str += "<td>" + flist[i].getPlanetName().substring(0,12) + "</td>";
        str += "<td>" + flist[i].tr + "</td>";
        str += "<td>" + flist[i].ex + "</td>";
        str += "<td>" + makeKaisan(flist[i]) + "</td>";
        str += "</tr>";
    }
    
    var flist = makeNewFleetList();
    if (flist.length > 0) {
        str += "<tr bgcolor='000000'><th colspan='7'>建造中の艦隊</th></tr>";
    }
    for (var i = 0; i < flist.length; i++) {
        str += "<tr>";
        str += "<td>" + flist[i].no + "</td>";
        str += "<td>" + flist[i].nvg + "</td>";
        str += "<td>" + flist[i].mlt + "(" + flist[i].getExpMlt() + ")</td>";
        str += "<td>" + flist[i].getPlanetName().substring(0,12) + "</td>";
        str += "<td>-</td>";
        str += "<td>-</td>";
        str += "<td>" + flist[i].msg + "</td>";
        str += "</tr>";
    }
    
    str += "</table>";
    str += '</div>';

    body.innerHTML = str;
    movingWinInfo.subWindow.disp();

    function makeKaisan(unit) {
        var isKaisan = unit.empire.isContainsKaisanList(unit.no);
        
        var str = "";
        str += '<select name="kaisan" key="' + unit.no
                + '" onchange="commitKaisan(' + unit.no + ')">';
        str += '<option value="0" '
                + (isKaisan ? '' : 'selected="selected"')
                + '>-</option>';
        str += '<option value="1" '
                + (isKaisan ? 'selected="selected"' : "")
                + '>廃棄</option>';
        str += '</select>';

        return str;
    }

    function makeFleetList() {
        var result = new Array();
        var fleet = this.userAgent.empire.fleet;
        for (var ix = 0; ix < fleet.length; ix++) {
            result.push(fleet[ix]);
        }
        return result;
    }

    function makeNewFleetList() {
        var e = this.userAgent.empire;
        var result = new Array();
        for (var ix = 0; ix < app.commandList.length; ix++) {
            var cmd = app.commandList[ix];
            if (cmd.empire.id != e.id) {
                continue;
            }
            if (cmd.id != CMD_ID_FLEET) {
                continue;
            }
            var unit = new FleetUnit(e, 0, e.nvg, e.mlt, cmd.planet.id, 0, 0);
            var f = e.getKaisanFleetByPlanetId(cmd.planet.id);
            unit.no = (f) ? f.no : "-";
            unit.msg = (f) ? "置換" : "新設";
            unit.msg = cmd.canBuild(this.userAgent, cmd.planet) ? unit.msg : "無効";
            
            result.push(unit);
        }
        return result;
    }

}

function commitKaisan(no) {
    no = parseInt(no);
    var list = document.getElementsByName("kaisan");
    var v = 0;
    for (var i = 0; i < list.length; i++) {
        var e = list[i];
        if (parseInt(e.getAttribute("key")) == no) {
            v = parseInt(e.value);
            break;
        }
    }
    var unit = this.userAgent.empire.getFleetByNo(no);
    if (v == 0) {
        if (this.userAgent.empire.isContainsKaisanList(no) ) {
            this.userAgent.empire.removeKaisanFleet(unit);
        }
    } else {
        if (! this.userAgent.empire.isContainsKaisanList(no) ) {
            this.userAgent.empire.addKaisanFleet(unit);
        }
    }
    clickDispFleet();
}

function clickKaisan() {
    var form = document.forms.subForm;
    var fleet = this.userAgent.empire.fleet;
    var kaisan = form.kaisan;
    if (! kaisan.value) {
        for (var i = 0; i < kaisan.length; i++) {
            var v = parseInt(kaisan[i].value);
            if (v > 0) {
                var key = kaisan[i].getAttribute("key");
                fleet[key] -= v;
            }
        }
    } else {
        var v = parseInt(kaisan.value);
        if (v > 0) {
            var key = kaisan.getAttribute("key");
            fleet[key] -= v;
        }
    }
    clickDispFleet();
    app.dispMapAndData();
}

// 艦隊ユニット
function FleetUnit(empire, no, nvg, mlt, pid, tr, ex) {
    this.empire = empire;
    this.no = (no) ? no : empire.getFleetNo();
    this.nvg = nvg;
    this.mlt = mlt;
    this.pid = (pid) ? pid : null;
    this.tr = (tr) ? tr : 0;
    this.ex = (ex) ? ex : 0;

    this.getName = function() {
        return "第" + this.no + "艦隊(" + this.getPlanetName() + ")";
    }

    this.getExpMlt = function() {
        return this.mlt + Math.floor( (this.tr + this.ex) / 40);
    }

    this.getPlanetName = function() {
        var p = app.getPlanetById(this.pid);
        if (p) {
            return p.name;
        }
        return "";
    }

    this.updateByTurn = function() {
        if (this.tr < 100) {
            this.tr++;
        }
        if (this.ex > 0) {
            this.ex--;
        }
    }

    this.updateExpByBattle = function() {
        this.ex += 5;
        this.ex = (this.ex > 100) ? 100 : this.ex;
    }

}