/**
 * Stars!
 * XML出力／取込機能
 *
 */

xmlmanager = null;
xmlReader = new XmlReader();

function clickXmlInOut() {
    if (app.selectMode) {
        app.finishSelectMode();
        cancelSCmd();
    }
    var subwin = document.getElementById("subWindow");
    subwin.style.width = "350px";
    subwin.style.height = "300px";
    var imgfile = (isIE()) ? "subwin3.gif" : "subwin3.png";
    var loadimg = (isIE()) ? "load.gif" : "load.png";
    var img = document.getElementById("subwinimg");
    img.setAttribute("src", imgfile);
    movingWinInfo.subWindow.disp();

    document.getElementById("windowTitleText").innerHTML="データ出力／取込";

    var e = document.getElementById("subBody");
    if (window.widget) {
        try {
            html = saveLoadWin();
        } catch(ex) {
            html = "<pre style='width: 280px; overflow: auto;'>" + ex + "</pre>";
        }
        e.innerHTML = html;
        return;
    }
    var xmlstr = setXmlData();
    var html = "<table>";
    html += "<tr><td>";
    html += "<textarea name='textarea0' wrap='hard' style='width: 335px; height: 225px;' id='xmltext'>";
    html += xmlstr;
    html += "</textarea>";
    html += "</td></tr>";
    html += "<tr><td>";
    html += "<div id='xmldata'></div>";
    html += "</td></tr>";
    html += "<tr><td>";
    html += "<img src='" + loadimg ;
    html += "' alt='取込' onclick='return inportXML();'";
    html += " style='position: absolute; top: 255px; left: 20px;'/>";
    html += "</td></tr>";
    html += "</table>";
    e.innerHTML = html;
}

function saveLoadWin() {
    var html = "";
    var cmd = widget.system("/bin/ls -lt savegame/*.savegame", null);
    var fileList = new Array();
    if (cmd.outputString) {
        var lineList = cmd.outputString.split(/\n/);
        for (var i = 0; i < lineList.length; i++) {
            var linedata = lineList[i].split(/[ \t]+/);
            if (linedata.length < 9) {
                continue;
            }
            var obj = new Object();
            if (linedata.length > 9) {
                obj.dateStr = linedata[5] + ' ' + linedata[6] + ' ' + linedata[8];
            } else {
                obj.dateStr = linedata[5] + ' ' + linedata[6];
            }
            obj.timeStr = linedata[7];
            obj.fname = linedata[linedata.length - 1];
            fileList.push(obj);
        }
    }
    var imgfile = (isIE()) ? "subwin2.gif" : "subwin2.png";
    var img = document.getElementById("subwinimg");
    img.setAttribute("src", imgfile);
    html += "<div style='width: 295px; height: 250px; overflow: auto;'>";
    html += "<table>";
    html += "<th>No.</th><th>日時</th><th>&nbsp;</th>";
    var maxno = 0;
    for (var i = 0; i < fileList.length; i++) {
        var no = parseInt(fileList[i].fname.substring(9, 14), 10);
        html += "<tr>";
        html += "<td>" + (i + 1) + "</td>";
        html += "<td><a href='javascript:loadFile(\"" ;
        html += fileList[i].fname + "\")'>" ;
        html += fileList[i].dateStr + " " + fileList[i].timeStr ;
        html += "</a></td>";
    if (no == 0) {
            html += "<td>AUTO SAVE</td>";
    }
        html += "</tr>";
        maxno = Math.max(maxno, no);
    }
    html += "</table>";
    html += "<div id='xmldata'></div>";
    html += "</div>";
    html += "<img src='save.png' onclick='saveFile(" + (maxno+1); 
    html += ");' alt='save' style='position: absolute; top: 265px; left: 20px;'/>";
    html += "<img src='finder.png' onclick='openFinder();' alt='finder' style='position: absolute; top: 265px; left: 100px;'/>";

    return html;
}

function saveFile(no) {
    if (! window.widget) {
        return;
    }
    var xml = exportXML();
    var filestr = formatXML(xml.getElementsByTagName("starsdata")[0], 0);
    if (filestr) {
        try {
        var fname = (new String(100000 + no)).substring(1, 6) + ".savegame";
        var cmd = widget.system("/bin/cat > savegame/" + fname, saveHandler);
        cmd.write(filestr);
        cmd.write(unescape("%0A"));
        cmd.close();
        } catch (ex) {
            widgetLogger.print(ex);
        }
    }
}

var readBuf = "";
function loadFile(fname) {
    try {
        readBuf = "";
        var cmd = widget.system("/bin/cat " + fname, loadHandler);
        cmd.onreadoutput = readHandler;
    } catch (ex) {
        var subwin = document.getElementById("subBody");
        var html = ex + "<br/>";
        subwin.innerHTML = html;
        widgetLogger.print("loadFile:" + ex);
    }
}

function isExistFile(fname) {
    var cmd = widget.system("/bin/ls " + fname, null);
    return (cmd.status == 0);
}

function openFinder() {
    widget.system("/usr/bin/open savegame/", null);
}

function saveHandler() {
    var subwin = document.getElementById("subWindow");
    subwin.style.display = "none";
}

function readHandler(output) {
    readBuf += output;
}

function loadHandler(output) {
    readHandler(output);
    try {
        widgetLogger.print("loadHandler:" + readBuf);
        loadXML(readBuf);
    } catch (ex) {
        var subwin = document.getElementById("subBody");
        var html = ex + "<br/>" + readBuf + "<br/>";
        subwin.innerHTML = html;
    }
}

function setXmlData() {
    var xml = exportXML();
    try {
        xmlstr = formatXML(xml.getElementsByTagName("starsdata")[0], 0);
    } catch (ex) {
        alert(ex);
    }
    return xmlstr;
}

function createChild(par, elm) {
    try {
        var e = xmlmanager.createElement(elm);
        par.appendChild(e);
    } catch (ex) {
        alert("createChild" + ex);
    }
    return e;
}

function getChildElements(elm, tagName) {
    var list = new Array();
    var nodes = elm.childNodes;
    for (var i = 0; i < nodes.length; i++) {
        var e = nodes[i];
        if (e.tagName.toUpperCase() == tagName.toUpperCase()) {
            list.push(e);
        }
    }

    return list;
}

function exportXML() {
    try {
        xmlmanager = new ActiveXObject("Microsoft.XMLDOM");
    } catch (e) {
        xmlmanager = document.implementation.createDocument("", "", null);
    }
    xmlmanager.async = false;
    var xml = xmlmanager.createElement("xml");
    var root =  createChild(xml, "starsdata");
    root.setAttribute("turn", app.turn);
    root.setAttribute("turnplayer", app.turnPlayer);
    root.setAttribute("difficulty", app.difficulty);
    root.setAttribute("baseversion", BASE_VERSION);

    var planetlist = createChild(root, "planetlist");
    for (var loc in app.starList) {
        var planet = createChild(planetlist, "planet");
        var p = app.starList[loc];
        planet.setAttribute("id", p.id);
        if (p.name) {
            planet.setAttribute("name", p.name);
        }
        planet.setAttribute("loc", p.loc);
        if (p.ctl) {
            planet.setAttribute("ctl", p.ctl.id);
            planet.setAttribute("dpl", p.dpl);
            planet.setAttribute("ecn", p.ecn);
            planet.setAttribute("dfc", p.dfc);
            planet.setAttribute("incp", p.inc_p);
        }
    }

    var empirelist = createChild(root, "empirelist");
    for (var ix in app.empireList) {
        if (! app.empireList[ix].id) {
            continue;
        }
        var empire = createChild(empirelist, "empire");
        var e = app.empireList[ix];
        empire.setAttribute("id", e.id);
        empire.setAttribute("name", e.name);
        empire.setAttribute("color", e.color);
        empire.setAttribute("fnd", e.fnd);
        empire.setAttribute("nvg", e.nvg);
        empire.setAttribute("mlt", e.mlt);
        empire.setAttribute("trs", e.trs);
        empire.setAttribute("fnd_p", e.fnd_p);
        empire.setAttribute("nvg_p", e.nvg_p);
        empire.setAttribute("mlt_p", e.mlt_p);
        empire.setAttribute("user_mode", e.user_mode ? "1" : "0");
        
        /* 艦隊 */
        var fleetlist = createChild(empire, "fleetlist");
        for (var fix = 0; fix < e.fleet.length; fix++) {
            var fleet = createChild(fleetlist, "fleet");
            var u = e.fleet[fix];
            fleet.setAttribute("no", u.no);
            fleet.setAttribute("nvg", u.nvg);
            fleet.setAttribute("mlt", u.mlt);
            if (u.pid) {
                fleet.setAttribute("pid", u.pid);
            }
            fleet.setAttribute("tr", u.tr);
            fleet.setAttribute("ex", u.ex);
        }
        
        /* 探索済リスト */
        var visibleList = createChild(empire, "visiblelist");
        for (var lk in e.visibleList) {
            var vs = createChild(visibleList, "visible");
            vs.setAttribute("loc", lk);
        }
    
        /* 植民船団 */
        var settlerList = createChild(empire, "settlerlist");
        for (var six = 0; six < e.settlerList.length; six++) {
            var st = createChild(settlerList, "settler");
            st.setAttribute("loc", e.settlerList[six]);
        }
    }

    var uchujuList = createChild(root, "uchujulist");
    for (var uix = 0; uix < app.uchuju.uchujuList.length; uix++) {
        var uchuju = createChild(uchujuList, "uchuju");
        var u = app.uchuju.uchujuList[uix];
        if (! u) {
            continue;
        }
        uchuju.setAttribute("uid", u.uid);
        uchuju.setAttribute("loc", u.loc);
        uchuju.setAttribute("force", u.force);
    }

    return xml;
}

function inportXML() {
    var textarea = document.getElementById("xmltext");
    var text = textarea.value;
    text = removeCr(text);
    loadXML(text);
}

function formatXML(elm, nest) {
    var str = "";
    for (var n = 0; n < nest; n++) {
        str += "  ";
    }
    str += "<" + elm.tagName;
    for (var ix = 0; ix < elm.attributes.length; ix++) {
        var attr = elm.attributes[ix];
        str += " " + attr.name + '="' + attr.value + '"';
    }
    str += ">\n";
    
    for (var ix = 0; ix < elm.childNodes.length; ix++) {
        var child = elm.childNodes[ix];
        str += formatXML(child, nest + 1);
    }
    
    for (var n = 0; n < nest; n++) {
        str += "  ";
    }
    str += "</" + elm.tagName;
    str += ">\n";

    return str;
}

function parseXML(mng, doc, text) {
    var rest = text;
    while (rest != "") {
        try {
            var elm = cutoutElement(rest);
            if (elm.tagname == "") {
                break;
            }
            var child = mng.createElement(elm.tagname);
            for (var ix = 0; ix < elm.attrlist.length; ix++) {
                var attr = elm.attrlist[ix];
                child.setAttribute(attr.name, attr.value);
            }
            doc.appendChild(child);
            rest = elm.reststr;
            if (elm.nodevalue == "") {
                continue;
            }
            parseXML(mng, child, elm.nodevalue);
        } catch (ex) {
            if (! ex.msg) {
                ex.msg = rest;
            }
            throw ex;
        }
    }
}

function cutoutElement(text) {
    var result = new Object();
    result.tagname = "";
    result.attrlist = new Array();
    result.nodevalue = "";
    result.reststr = "";

    var sts = text.indexOf("<", 0);
    var ste = text.indexOf(">", sts + 1);
    var tagtext = text.substring(sts, ste + 1);
    var tne = tagtext.search(/[\s>\/]/);
    result.tagname = tagtext.substring(1, tne);

    var rest = tagtext.substring(tne + 1);
    while (rest != "") {
        var aloc = rest.search(/\w+=\"[^\"]*\"/);
        if (aloc < 0) {
            break;
        }
        var attrstr = rest.match(/\w+=\"[^\"]*\"/);
        if (attrstr == null) {
            break;
        }
        attrstr = new String(attrstr);
        var attr = new Object();
        var eq = attrstr.indexOf("=", 0);
        attr.name = attrstr.substring(0, eq);
        attr.value = attrstr.substring(eq + 2, attrstr.length - 1);
        result.attrlist.push(attr);
        rest = rest.substring(aloc + attrstr.length);
    }

    if (text.charAt(ste - 1) == "/") {
        result.reststr = text.substring(ste + 1);
        return result;
    }

    var ets = text.indexOf("</" + result.tagname, ste + 1);
    if (ets < 0) {
        return result;
    }
    var ete = text.indexOf(">", ets + 1);
    if (ete < 0) {
        return result;
    }
    result.nodevalue = text.substring(ste + 1, ets);
    result.reststr = text.substring(ete + 1);
    return result;
}

function loadXML(text) {
    try {
        app.init();
        app.empireList = new Array();   // 星間国家リスト
        app.starList = new Object();    // 惑星リスト
        var xml = null;

        if (isIE() ) {
            xmlmanager = new ActiveXObject("Microsoft.XMLDOM");
            xmlmanager.async = false;
            xml = xmlmanager.createElement("xml");
            xmlmanager.appendChild(xml);
        } else {
            xmlmanager = document;
            xml = document.getElementById("xmldata");
        }
        parseXML(xmlmanager, xml, text);
        var root = getChildElements(xml, "starsdata")[0];
        app.turn = parseInt(root.getAttribute("turn"));
        app.turnPlayer = parseInt(root.getAttribute("turnplayer"));
        var difficulty = root.getAttribute("difficulty");
        app.difficulty = (difficulty) ? parseInt(difficulty) : 2;

        var empireList = getChildElements(root, "empirelist")[0];
        var empires = getChildElements(empireList, "empire");
        for (var eix = 0; eix < empires.length; eix++) {
            var empire = empires[eix];
            var id = parseInt(empire.getAttribute("id"));
            var name = empire.getAttribute("name");
            name = (name) ? name : "";
            var color = empire.getAttribute("color");
            var fnd = parseInt(empire.getAttribute("fnd"));
            var nvg = parseInt(empire.getAttribute("nvg"));
            var mlt = parseInt(empire.getAttribute("mlt"));
            var trs = parseInt(empire.getAttribute("trs"));
            var umode = (empire.getAttribute("user_mode") == "1");
            var fnd_p = parseInt(empire.getAttribute("fnd_p"));
            var nvg_p = parseInt(empire.getAttribute("nvg_p"));
            var mlt_p = parseInt(empire.getAttribute("mlt_p"));
            var e = new Empire(id, name, color, fnd, nvg, mlt,
            trs, umode, fnd_p, nvg_p, mlt_p);

            app.empireList.push(e);
            if (umode) {
                app.userAgent = e.ai;
            }

            /* 艦隊 */
            var fleetList = getChildElements(empire, "fleetlist")[0];
            if (fleetList) {
                var fleets = getChildElements(fleetList, "fleet");
                for (var fix = 0; fix < fleets.length; fix++) {
                    var fleet = fleets[fix];
                    var nvg = parseInt(fleet.getAttribute("nvg"));
                    var mlt = parseInt(fleet.getAttribute("mlt"));
                    if (fleet.getAttribute("count")) {
                        var cnt = parseInt(fleet.getAttribute("count"));
                        for (var cix = 0; cix < cnt; cix++) {
                        }
                    }
                    var no = 0;
                    if (fleet.getAttribute("no")) {
                        no = parseInt(fleet.getAttribute("no"));
                    }
                    var pid = 0;
                    if (fleet.getAttribute("pid")) {
                        pid = parseInt(fleet.getAttribute("pid"));
                    }
                    var u = new FleetUnit(e, no, nvg, mlt, pid)
                    if (fleet.getAttribute("tr")) {
                        u.tr = parseInt(fleet.getAttribute("tr"));
                    }
                    if (fleet.getAttribute("ex")) {
                        u.ex = parseInt(fleet.getAttribute("ex"));
                    }
                    e.addFleet(u);
                }
            }
            /* 探査済リスト */
            var visibleList = getChildElements(empire, "visiblelist");
            e.visibleList = new Object();
            if (visibleList.length > 0) {
                visibleList = visibleList[0];
                var cells = getChildElements(visibleList, "visible");
                for (var cix = 0; cix < cells.length; cix++) {
                    var loc = cells[cix].getAttribute("loc");
                    e.visibleList[loc] = true;
                }
            }
            
            /* 植民船団 */
            var settlerList = getChildElements(empire, "settlerlist");
            e.settlerList = new Array();
            if (settlerList.length > 0) {
                settlerList = settlerList[0];
                var settlers = getChildElements(settlerList, "settler");
                for (var six = 0; six < settlers.length; six++) {
                    var loc = settlers[six].getAttribute("loc");
                    e.settlerList.push(loc);
                }
            }
        }

        var planetList = getChildElements(root, "planetlist")[0];
        var planets = getChildElements(planetList, "planet");
        for (var pix = 0; pix < planets.length; pix++) {
            var planet = planets[pix];
            var id = parseInt(planet.getAttribute("id"));
            var loc = planet.getAttribute("loc");
            var name = planet.getAttribute("name");
            var ctlix = parseInt(planet.getAttribute("ctl"));
            var dpl = parseInt(planet.getAttribute("dpl"));
            var ecn = parseInt(planet.getAttribute("ecn"));
            var dfc = parseInt(planet.getAttribute("dfc"));
            var incp = parseInt(planet.getAttribute("incp"));
            var ctl = null;
            if (ctlix > 0) {
                ctl = app.empireList[ctlix - 1];
            }

            app.starList[loc] = new Planet(id, loc, name, ctl, dpl, ecn, dfc, incp)
                    app.spaceMap[loc] = true;
        }

        app.uchuju.id = 0;
        var uchujuList = getChildElements(root, "uchujulist")[0];
        var uchujus = getChildElements(uchujuList, "uchuju");
        for (var uix = 0; uix < uchujus.length; uix++) {
            var uchuju = uchujus[uix];
            var uid = parseInt(uchuju.getAttribute("uid"));
            var loc = uchuju.getAttribute("loc");
            var force = parseInt(uchuju.getAttribute("force"));
            var mgr = app.uchuju;
            var u = new UchujuUnit(mgr, uid, loc, force);
            app.uchuju.uchujuList.push(u);
            if (u.id > app.uchuju.id) {
                app.uchuju.id = u.id;
            }
        }

        for (var eix = 0; eix < app.empireList.length; eix++) {
            app.empireList[eix].makeCtlList();
        }

        app.trade = Trade(this.empireList);
        for (var eix = 0; eix < app.empireList.length; eix++) {
            app.empireList[eix].ai.findUndplList();
        }
        for (var eix = 0; eix < app.empireList.length; eix++) {
            app.empireList[eix].ai.findUndplList();
        }
        
        app.curMsgList = new Array();
        app.uchuju.calTec();
        app.settlerMap = app.makeSettlerMap();

        app.dispMapAndData();
        clickCloseSub();
    } catch (ex) {
        alert("取込データが正しくありません。");
        if (ex.msg) {
            alert(ex.msg);
        } else {
            alert(ex);
        }
        return false;
    }
    var diff = "普通";
    if (app.difficulty == 1) {
        diff = "簡単";
    } else if (app.difficulty == 3) {
        diff = "困難";
    } else if (app.difficulty == 4) {
        diff = "至難";
    }
    printConsole(this.userAgent.empire.id,
    "ターン：" + app.turn + " 難易度：" + diff);
    app.afterMsgFunc = this.enableButtonArea;
    dispAllMsg();

    return true;
}

function removeCr(text) {
    for(var loc = text.indexOf("\n", 0); loc >= 0; loc = text.indexOf("\n", 0)) {
        text = text.substring(0, loc) + text.substring(loc + 1, text.length);
    }
    return text;
}

function XmlReader() {
    this.xml = null;
    this.handler = null;
    try {
        if (isSafari()) {
            this.xml = new XMLHttpRequest();
            this.xml.onload = handleXmlEvent;
        } else if( document.implementation && document.implementation.createDocument ) {
            this.xml = document.implementation.createDocument("", "", null);
            this.xml.onload = handleXmlEvent;
        } else {
            this.xml = new ActiveXObject("Microsoft.XMLDOM");
            this.xml.onreadystatechange = handleXmlEvent;
        }
    } catch (e) {
        alert("XMLに未対応:" + e);
    }

    this.readXml = function(filePath, handler){
        this.handler = handler;
        if (this.xml == null) {
            this.handler(null);
        }
        if (isSafari() ) {
            try{
                this.xml.open("GET", filePath, true);
                this.xml.send(null);
            } catch (e) {
                handler(null);
            }
         } else {
            this.xml.load(filePath);
        }
    }
}

function handleXmlEvent() {
    if (xmlReader.xml.readyState) {
        if (xmlReader.xml.readyState == 4) {
            if(xmlReader.xml.parseError && xmlReader.xml.parseError.status) {
                if (xmlReader.xml.parseError.status == 200) {
                    xmlReader.handler(xmlReader.xml);
                } else {
                    xmlReader.handler(null);
                }
            } else {
                xmlReader.handler(xmlReader.xml);
            }
        }
     } else {
        xmlReader.handler(xmlReader.xml);
     }
}

function isIE() {
    if( document.implementation && document.implementation.createDocument ) {
        return false;
    }
    return true;
}

function isIPhone() {
    var ua = navigator.userAgent;
    return (ua.indexOf("iPhone") != -1);
}

function isKonqueror() {
    var ua = navigator.userAgent;
    return (ua.indexOf("Konqueror") != -1);
}

function isSafari() {
    if (window.widget) {
        return true;
    }
    var ua = navigator.userAgent;
    return (ua.indexOf("Safari") != -1);
}


